﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.01
@EndOfDesignText@
'version 1.00
#Event: UpdateHeaderHeight (Height As Int, Fraction As Float)
Sub Class_Globals
	Public mHeader As B4XView
	Private ScrollGestureStartPosition As Int
	Public MaxHeaderHeight As Int = 300dip
	Public MinHeaderHeight As Int = 100dip
	Private mCLV As CustomListView
	Private mCallback As Object
	Private mEventName As String
End Sub

Public Sub Initialize (Callback As Object, EventName As String, Header As B4XView, clv As CustomListView)
	mCLV = clv
	#if B4i
	Dim sv As ScrollView = mCLV.sv
	sv.Bounces = False
	#End If
	mHeader = Header
	mCallback = Callback
	mEventName = EventName
	Header.BringToFront
End Sub

Public Sub Resize (Width As Double, Height As Double)
	mHeader.Width = Width
	#if B4i
	Sleep(50)
	#else
	Sleep(0)
	#end if
	SetSVTop(MaxHeaderHeight)
End Sub

Public Sub ScrollChanged (Position As Int)
	Dim delta As Int = (Position - ScrollGestureStartPosition) / 3
	delta = Max(-20dip, Min(20dip, delta))
	ScrollGestureStartPosition = Position
	Dim NewSVTop As Int = Min(MaxHeaderHeight, Max(mCLV.sv.Top - delta, MinHeaderHeight))
	If mCLV.sv.Top <> NewSVTop Then
		SetSVTop(NewSVTop)
	End If
End Sub

Private Sub SetSVTop (svtop As Int)
	mCLV.sv.Top = svtop
	mHeader.Height = svtop
	mCLV.sv.Height = mCLV.AsView.Height - mCLV.sv.Top
	Dim fraction As Float = (mHeader.Height - MinHeaderHeight) / (MaxHeaderHeight - MinHeaderHeight)
	CallSub3(mCallback, mEventName & "_UpdateHeaderHeight", svtop, fraction)
End Sub